// Sample program that does nothing sensible but demonstrates how to use constexpr
template <uint N>
struct ZeroArray
{
    uint vals[N];

    constexpr ZeroArray(): vals()
    {
        for (uint j = 0; j < N; ++j)
        {
            vals[j] = 0;
        }
    }
};

struct InitializedArray
{
    uint vals[1000];
    constexpr InitializedArray(): vals()
    {
        for (uint j = 0; j < 1000; ++j)
        {
            vals[j] = j * 3;
        }
    }
};

constexpr InitializedArray globArr;

constexpr uint stateSize(uint n)
{
    return 6;
}

constexpr void processOne(uint n, uint i, uint curr, State& state)
{
    uint base = 141;
    uint mod = 1000;
    uint cur = 0;
    for(uint j=0; j<(i%100); j++)
    {
        cur*=base;
        cur+=(j%36);
        cur%=1000;
    }
    uint sum = 0;
    for(uint j=0; j<6; j++)
    {
        sum+=state[j];
    }
    uint c = 1000-sum;
    for(uint j=0; j<6; j++)
    {
        if(c <= cur)
        {
            state[j+1]++;
            break;
        }
        c+=state[j];
    }
}

constexpr uint getAnswer(uint n, const State& state)
{
    uint ans = 0;
    for(uint i=0; i<6; i++)
    {
        ans += (state[i]*(i*i));
    }
    return ans;
//    ZeroArray<50> arr;
//    for (uint i = 0; i < n; ++i)
//    {
//        arr.vals[i % 50] += 2;
//        arr.vals[(i + globArr.vals[i] + state[i % 2]) % 50] += arr.vals[i % 50];
//    }
//    return arr.vals[49];
}
