#include<iostream>
#include<vector>
#include<algorithm>
using namespace std;

const int mnogo = 1000000007;

int broiChisla;
int broiGrupi;

int chisla[1000010];

struct DanniZaVarha{
    int naiGolqmoto;
    int otKadeObhvashta;
    int doKadeObhvashta;
    int lqvoDete;
    int dqsnoDete;
};

vector<DanniZaVarha> varhove;
int korenNomer = -1;

int daiNovVrah(DanniZaVarha novVrah){
    varhove.push_back(novVrah);
    return varhove.size() - 1;
}

int napraviDarvo(int otKade, int doKade){
    if(otKade == doKade){
        return daiNovVrah({chisla[otKade], otKade, doKade, -1, -1});
    }

    int lqvoDete = napraviDarvo(otKade, (otKade + doKade)/2);
    int dqsnoDete = napraviDarvo((otKade + doKade)/2 + 1, doKade);

    int tukaStoinost = max(varhove[lqvoDete].naiGolqmoto, varhove[dqsnoDete].naiGolqmoto);

    return daiNovVrah({tukaStoinost, otKade, doKade, lqvoDete, dqsnoDete});
}

int query(int segashenVrah, int otKade, int doKade){
    if(segashenVrah == -1 || otKade > varhove[segashenVrah].doKadeObhvashta || doKade < varhove[segashenVrah].otKadeObhvashta){
        return 0;
    }

    if(otKade <= varhove[segashenVrah].otKadeObhvashta && doKade >= varhove[segashenVrah].doKadeObhvashta){
        return varhove[segashenVrah].naiGolqmoto;
    }

    return max(query(varhove[segashenVrah].lqvoDete, otKade, doKade), query(varhove[segashenVrah].dqsnoDete, otKade, doKade));
}

int minimalniMbMin(int doKade, int vKolkoGrupi){
    if(doKade == 0){
        if(vKolkoGrupi == 0){
            return 0;
        }else{
            return mnogo;
        }
    }
    if(vKolkoGrupi > doKade || vKolkoGrupi <= 0){
        return mnogo;
    }

    int tukaNaiM = chisla[doKade] + minimalniMbMin(doKade - 1, vKolkoGrupi - 1);

    for(int i = 2; i <= doKade; i++){
        int tekushto = chisla[doKade]*i + minimalniMbMin(doKade - i, vKolkoGrupi - 1);

        tukaNaiM = min(tukaNaiM, tekushto);
    }

    return tukaNaiM;
}

int main(){

    cin>>broiChisla>>broiGrupi;

    for(int i = 1; i <= broiChisla; i++){
        cin>>chisla[i];
    }

    sort(chisla, chisla + broiChisla + 1);

    /*for(int i = 1; i <= broiChisla; i++){
        cout<<chisla[i]<<" ";
    }
    cout<<endl;*/

    //korenNomer = napraviDarvo(0, broiChisla - 1);

    cout<<minimalniMbMin(broiChisla, broiGrupi)<<endl;

    return 0;
}
