#pragma GCC optimize ("Ofast")
#pragma unroll
#include <iostream>
#include <vector>
#include <algorithm>
#define endl '\n'
using namespace std;

const int MAXSIM = 1e6;

int sim, marks, optimal;
long long mem[MAXSIM];
vector<int> markIDs;

long long avrg(int l, int r) {
    long long avrg = 0;
    for (int i = l; i <= r; i++) {
        avrg += mem[i];
    }
    avrg /= (r - l) + 1;
    return avrg;
}

int binaryS(int l, int r, int key) {
    int m;
    while (l <= r) {
        m = (l + r) / 2;
        if (key == mem[m]) {
            return m;
        } else if (key > mem[m]) {
            l = m + 1;
            if (l > r) {
                return m;
            }
        } else {
            r = m - 1;
            if (l > r) {
                return m - 1;
            }
        }
    }
}

void putMarksLeft(int l, int r, int mCount) {
    if (l > r || mCount <= 0) return;
    int tID = binaryS(l, r, avrg(l, r));
    if (r - l == 1)
        tID++;
    markIDs.push_back(tID);
    mCount--;
    putMarksLeft(l, tID - 1, mCount);
}

void putMarksRight(int l, int r, int mCount) {
    if (l > r || mCount <= 0) return;
    int tID = binaryS(l, r, avrg(l, r));
    if (r - l == 1)
        tID++;
    markIDs.push_back(tID);
    mCount--;
    putMarksRight(tID + 1, r, mCount);
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    // input
    cin >> sim >> marks;
    for (int i = 0; i < sim; i++) {
        cin >> mem[i];
    }

    // solve
    sort(mem, mem + sim);
    int tID = binaryS(0, sim - 1, avrg(0, sim - 1));
    markIDs.push_back(tID);
    marks--;
    if (marks % 2 == 0) {
        putMarksLeft(0, tID - 1, marks / 2);
        putMarksRight(tID + 1, sim - 1, marks / 2);
    } else {
        putMarksLeft(0, tID - 1, marks / 2);
        putMarksRight(tID + 1, sim - 1, marks / 2 + 1);
    }
    sort(markIDs.begin(), markIDs.end());
    for (int i = 0, lastID = -1; i < markIDs.size(); i++) {
        optimal += mem[markIDs[i]] * (markIDs[i] - lastID);
        lastID = markIDs[i];
    }

    cout << optimal << endl;
    return 0;
}
