#pragma GCC optimize ("Ofast")
#pragma unroll
#include <iostream>
#include <vector>
#include <algorithm>
#define endl '\n'
using namespace std;

const int MAXSIM = 1e6;

int sim, marks;
long long mem[MAXSIM];
long long optimal = 10*1e12;

void updateOptimal(vector<int> vec) {
    sort(vec.begin(), vec.end());
    long long currOptimal = 0;
    for (int i = 0, lastID = -1; i < vec.size(); i++) {
        currOptimal += mem[vec[i]] * (vec[i] - lastID);
        lastID = vec[i];
    }
    optimal = min(currOptimal, optimal);
}

void calc(int depth, vector<int> vec) {
    if (depth >= marks) {
        vec[vec.size() - 1] = sim - 1;
        updateOptimal(vec);
        return;
    }
    for (int i = 0; i < sim; i++) {
        if (find(vec.begin(), vec.end(), i) != vec.end()) continue;
        vec.push_back(i);
        calc(depth + 1, vec);
        vec.erase(vec.end() - 1, vec.end());
    }
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    // input
    cin >> sim >> marks;
    for (int i = 0; i < sim; i++) {
        cin >> mem[i];
    }

    // solve
    sort(mem, mem + sim);
    vector<int> markIDs;
    calc(0, markIDs);

    // output
    cout << optimal << endl;

    return 0;
}
