#include<iostream>
#include<vector>
#include<utility>
#include<map>
#include<algorithm>

using namespace std;

const long long N = 8010, inf = 1e18;
long long a[N], w[N][N];

long long solve(long long j, long long i)
{
    long long l = j, r = i, mid, ans = inf;
    while(l <= r)
    {
        //cout << l << " " << r << endl;
        mid = (l + r) / 2;
        long long il = (i - (mid - 1) + 1) * a[i] + w[j - 1][mid - 1 - 1];
        long long ir = (i - (mid + 1) + 1) * a[i] + w[j - 1][mid + 1 - 1];
        long long ii = (i - mid + 1) * a[i] + w[j - 1][mid - 1];
        if(mid - 1 < l) il = inf;
        if(mid + 1 > r) ir = inf;
        if(ii < il && ii < ir) return mid;
        else if(il < ir) r = mid - 1, ans = mid - 1;
        else l = mid + 1, ans = mid + 1;
    }
    return ans;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    long long n, k;
    cin >> n >> k;
    for(long long i = 1; i <= n; ++i) cin >> a[i];
    sort(a + 1, a + n + 1);

    //for(int i = 1; i <= n; ++i) cout << a[i] << " ";
    //cout << endl;
    for(long long i = 1; i <= n; ++i)
    {
        w[1][i] = i * a[i];
        for(long long j = 2; j <= min(i, k); ++j)
        {
            w[j][i] = inf;
            int u = solve(j, i);
            w[j][i] = (i - u + 1) * a[i] + w[j - 1][u - 1];
            /*cout << "---------------------" << endl;
            for(long long r = i; r >= j; --r)
            {
                w[j][i] = min(w[j][i], (i - r + 1) * a[i] + w[j - 1][r - 1]);
                cout << r << ": " << (i - r + 1) * a[i] + w[j - 1][r - 1] << endl;
            }
            cout << "---------------------" << endl;*/
        }
    }
    //for(int i = 1; i <= k; ++i, cout << endl)
    //    for(int j = 1; j <= n; ++j) cout << w[i][j] << " ";
    cout << w[k][n] << endl;
    return 0;
}
