#include <iostream>
#include <vector>
#define endl '\n'
using namespace std;

const int BUFFER_LENGTH = 100000;

char buffer[BUFFER_LENGTH];
int buffer_pos = 0;

void read_char()
{
    if (++ buffer_pos == BUFFER_LENGTH) fread(buffer, 1, BUFFER_LENGTH, stdin), buffer_pos = 0;
}

int int_value;

int read_int()
{
    int_value = 0;
    for (; buffer[buffer_pos] < '0' or buffer[buffer_pos] > '9'; read_char());
    for (; buffer[buffer_pos] >= '0' and buffer[buffer_pos] <= '9'; read_char())
    {
        int_value = int_value * 10 + (buffer[buffer_pos] - '0');
    }
    return int_value;
}

const int MAXN = 80000;

int c[MAXN + 5];
vector<int> G[MAXN + 5], colors[MAXN + 5];;

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n;
    n = read_int();

    for (int i = 1; i <= n; ++ i)
    {
        c[i] = read_int();
    }

    for (int i = 1; i < n; ++ i)
    {
        int u, v;
        u = read_int();
        v = read_int();
        G[u].push_back(v);
        G[v].push_back(u);
    }

    vector<int> chain;
    chain.push_back(0);
    for (int i = 1; i <= n; ++ i)
    {
        if (G[i].size() == 1)
        {
            int u = i, p = 0;
            chain.push_back(c[u]);
            do
            {
                for (auto v : G[u])
                {
                    if (v != p)
                    {
                        u = v;
                        p = u;
                        break;
                    }
                }
                chain.push_back(c[u]);
            } while (G[u].size() != 1);
            break;
        }
    }

    for (int i = 1; i <= n; ++ i)
    {
        int t = chain[i];
        colors[t].push_back(i);
    }

    int q;
    q = read_int();

    for (int i = 1; i <= q; ++ i)
    {
        int x, y;
        x = read_int();
        y = read_int();
        long long res = 0;
        for (auto posx : colors[x])
        {
            int posy = lower_bound(colors[y].begin(), colors[y].end(), posx) - colors[y].begin();
            res += 1ll * posy * (colors[y].size() - posy);
        }
        cout << res << endl;
    }

    return 0;
}
