#include <algorithm>
#include <iostream>
#include <vector>
#define endl '\n'
using namespace std;

const int BUFFER_LENGTH = 100000;

char buffer[BUFFER_LENGTH];
int buffer_pos = 0;

void read_char()
{
    if (++ buffer_pos == BUFFER_LENGTH) fread(buffer, 1, BUFFER_LENGTH, stdin), buffer_pos = 0;
}

int int_value;

int read_int()
{
    int_value = 0;
    for (; buffer[buffer_pos] < '0' or buffer[buffer_pos] > '9'; read_char());
    for (; buffer[buffer_pos] >= '0' and buffer[buffer_pos] <= '9'; read_char())
    {
        int_value = int_value * 10 + (buffer[buffer_pos] - '0');
    }
    return int_value;
}

const int MAXN = 80000;

int c[MAXN + 5];
vector<int> colors[MAXN + 5];

bool check(int x, int y, int l, int r)
{
    if (l == r) return false;
    int p = lower_bound(colors[y].begin(), colors[y].end(), colors[x][l]) - colors[y].begin();
    if (p >= colors[y].size() or colors[y][p] > colors[x][r]) return false;
    return true;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n;
    n = read_int();

    for (int i = 1; i <= n; ++ i)
    {
        c[i] = read_int();
    }

    for (int i = 1; i < n; ++ i)
    {
        int u, v;
        u = read_int();
        v = read_int();
    }

    for (int i = 1; i <= n; ++ i)
    {
        colors[c[i]].push_back(i);
    }

    int q;
    q = read_int();

    for (int i = 1; i <= q; ++ i)
    {
        int x, y;
        x = read_int();
        y = read_int();
        int l = 0;
        int p = lower_bound(colors[y].begin(), colors[y].end(), colors[x][l]) - colors[y].begin();
        if (p >= colors[y].size())
        {
            cout << 0 << endl;
            continue;
        }
        int r = lower_bound(colors[x].begin(), colors[x].end(), colors[y][p]) - colors[x].begin();
        if (r >= colors[x].size())
        {
            cout << 0 << endl;
        }
        long long res = 0;
        while (r < colors[x].size())
        {
            res += l + 1;
            r++;
            while (check(x, y, l, r)) l++;
            l--;
        }
        cout << res << endl;
    }

    return 0;
}
