#include <iostream>
#include <vector>
#define endl '\n'
using namespace std;

const int BUFFER_LENGTH = 100000;

char buffer[BUFFER_LENGTH];
int buffer_pos = 0;

void read_char()
{
    if (++ buffer_pos == BUFFER_LENGTH) fread(buffer, 1, BUFFER_LENGTH, stdin), buffer_pos = 0;
}

int int_value;

int read_int()
{
    int_value = 0;
    for (; buffer[buffer_pos] < '0' or buffer[buffer_pos] > '9'; read_char());
    for (; buffer[buffer_pos] >= '0' and buffer[buffer_pos] <= '9'; read_char())
    {
        int_value = int_value * 10 + (buffer[buffer_pos] - '0');
    }
    return int_value;
}

const int MAXN = 10000;

int color = 0;
int c[MAXN + 5];
int first[MAXN + 5];
vector<int> G[MAXN + 5];
int ans[MAXN + 5][MAXN + 5];

int DFS(int u, int p)
{
    if (first[c[u]] == 0) first[c[u]] = u;

    int cnt = 0;
    if (c[u] == color) cnt++;
    for (auto v : G[u])
    {
        if (v != p)
        {
            cnt += DFS(v, u);
        }
    }

    if (first[c[u]] == u)
    {
        ans[color][c[u]] += cnt;
        first[c[u]] = 0;
    }

    return cnt;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n;
    n = read_int();

    for (int i = 1; i <= n; ++ i)
    {
        c[i] = read_int();
    }

    for (int i = 1; i < n; ++ i)
    {
        int u, v;
        u = read_int();
        v = read_int();
        G[u].push_back(v);
        G[v].push_back(u);
    }

    for (int i = 1; i <= n; ++ i)
    {
        color = c[i];
        DFS(i, 0);
    }

    int q;
    q = read_int();

    for (int i = 1; i <= q; ++ i)
    {
        int x, y;
        x = read_int();
        y = read_int();
        cout << ans[x][y] / 2 << endl;
    }

    return 0;
}
