#include <bits/stdc++.h>
using namespace std;
#ifdef EVAL
#define cerr if(false)cerr
#endif // EVAL
#define endl "\n"
typedef long long ll;
const ll mod = 1e18 + 7;
template<class T, class T2> bool chkmin(T &a, const T2 &b) { return (a > b) ? a = b, 1: 0;}
template<class T, class T2> bool chkmax(T &a, const T2 &b) { return (a < b) ? a = b, 1: 0;}

const ll MAX_N = 1e6 + 10;
ll n, k;
ll arr[MAX_N];

struct Line {
    ll m, b;
    long double p;
    ll cnt = 0;

    Line(ll m, ll b, ll cnt) : m(m), b(b), cnt(cnt) {
        p = mod;
    }
    Line() {
        p = mod;
    }
};

long double llersect(const Line &a, const Line &b) {
    return (a.b - b.b) / (b.m - a.m);
}

struct LineContainer {
    deque<Line> cont;

    void push_back(Line nw) {
        while(cont.size() >= 2 && llersect(cont[cont.size() - 2], nw) < cont[cont.size() - 2].p) {
            cont.pop_back();
        }
        if(!cont.empty()) {
            cont[cont.size() - 1].p = llersect(cont[cont.size() - 1], nw);
        }
        cont.push_back(nw);
    }

    pair<ll, ll> ans(ll x) {
        while(!cont.empty() && x > cont.front().p) {
            cont.pop_front();
        }
        if(cont.empty()) {
            return {0, mod};
        }
        return {cont.front().cnt, cont.front().m * x + cont.front().b};
    }
};

ll ans;
LineContainer what;

bool eval(ll x) {
    what.push_back(Line(0, 0, 0));

    ll last;

    for(ll i = 1; i <= n; i ++) {
        const auto now = what.ans(arr[i]);
        ll curr = min(mod, now.second + i * arr[i] + x);
        if(curr < mod) {
            what.push_back(Line(-i, curr, now.first + 1));
        }
        last = now.first;
        ans = curr;
    }

    what.cont.resize(0);

    return last + 1 <= k;
}

void solve_extrafast() {
    ll l = -mod, r = mod;
    while(l < r - 1) {
        ll m = (l + r) / 2;
        if(eval(m)) {
            r = m;
        } else {
            l  =m;
        }
    }

    eval(r);
    cout << ans - r * k << endl;
}

signed main() {
#ifdef EVAL
    ios_base::sync_with_stdio(false); cin.tie(NULL);
#endif // EVAL

    cin >> n >> k;
    for(ll i = 1; i <= n; i ++) {
        cin >> arr[i];
    }
    sort(arr + 1, arr + n + 1);

    solve_extrafast();

    return 0;
}
