#include <bits/stdc++.h>
using namespace std;
#ifdef EVAL
#define cerr if(false)cerr
#endif // EVAL
#define endl "\n"
typedef long long ll;
const long double mod = 1e20 + 7;
template<class T, class T2> bool chkmin(T &a, const T2 &b) { return (a > b) ? a = b, 1: 0;}
template<class T, class T2> bool chkmax(T &a, const T2 &b) { return (a < b) ? a = b, 1: 0;}

const ll MAX_N = 1e6 + 10;
ll n, k;
ll arr[MAX_N];

typedef long double ld;

struct Line {
    long double m, b;
    long double p;
    ll cnt = 0;

    Line(ld m, ld b, ll cnt) : m(m), b(b), cnt(cnt) {
        p = mod;
    }
    Line() {
        p = mod;
    }
};

long double llersect(const Line &a, const Line &b) {
    return (a.b - b.b) / (b.m - a.m);
}

struct LineContainer {
    deque<Line> cont;

    void push_back(Line nw) {
        while(cont.size() >= 2 && llersect(cont[cont.size() - 2], nw) < cont[cont.size() - 2].p) {
            cont.pop_back();
        }
        if(!cont.empty()) {
            cont[cont.size() - 1].p = llersect(cont[cont.size() - 1], nw);
        }
        cont.push_back(nw);
    }

    pair<ll, ld> ans(ld x) {
        while(!cont.empty() && x > cont.front().p) {
            cont.pop_front();
        }
        if(cont.empty()) {
            return {0, mod};
        }
        return {cont.front().cnt, cont.front().m * x + cont.front().b};
    }
};

ld ans;
LineContainer what;

bool eval(long double x) {
    what.push_back(Line(0, 0, 0));

    ll last;

    for(ll i = 1; i <= n; i ++) {
        const auto now = what.ans(arr[i]);
        ld curr = now.second + i * arr[i] + x;
        what.push_back(Line(-i, curr, now.first + 1));
        last = now.first;
        ans = curr;
    }

    what.cont.resize(0);

    if(last + 1 == k) {
        cout << (ll)(ans - x * (long double)k + 0.5) << endl;
        exit(0);
    }

    return last + 1 <= k;
}

void solve_extrafast() {
    ld l = -mod, r = mod;
    while(r - l > 1e-6) {
        ld m = (l + r) / 2.0;

        if(eval(m)) {
            r = m;
        } else {
            l = m;
        }
    }

    eval(r);
    cout << (ll)(ans - r * (long double)k + 0.5) << endl;
}

struct Line2 {
    ll m, b;
    long double p;

    Line2() {
        p = 1e18;
    }
    Line2(ll m, ll b) : m(m), b(b) {
        p = 1e18;
    }
};

long double intersect(const Line2 &a, const Line2 &b) {
    return (a.b - b.b) / (b.m - a.m);
}

struct LineContainer2 {
    deque<Line2> cont;

    void push_back(Line2 nw) {
        while(cont.size() >= 2 && intersect(cont[cont.size() - 2], nw) < cont[cont.size() - 2].p) {
            cont.pop_back();
        }
        if(!cont.empty()) {
            cont[cont.size() - 1].p = intersect(cont[cont.size() - 1], nw);
        }
        cont.push_back(nw);
    }

    ll ans(ll x) {
        while(!cont.empty() && x > cont.front().p) {
            cont.pop_front();
        }
        if(cont.empty()) {
            return 1e18;
        }
        return cont.front().m * x + cont.front().b;
    }
};

const ll SMALL_N = 2e4 + 10;
LineContainer2 lc[SMALL_N];

ll solve_fast() {
    for(int i = 0; i <= k; i ++) {
        lc[i].cont.resize(0);
    }
    lc[0].push_back(Line2(0, 0));

    for(int i = 1; i <= n; i ++) {
        for(int j = k; j >= 1; j --) {
            const ll MOD = 1e18;
            ll curr = min(MOD, lc[j - 1].ans(arr[i]) + i * arr[i]);
            if(curr < MOD) {
                lc[j].push_back(Line2(-i, curr));
            }
        }
    }

    return lc[k].cont.back().b;
    cout << lc[k].cont.back().b << endl;
}

signed main() {
#ifdef EVAL
    ios_base::sync_with_stdio(false); cin.tie(NULL);
#endif // EVAL

    cin >> n >> k;
    for(ll i = 1; i <= n; i ++) {
        cin >> arr[i];
    }
    sort(arr + 1, arr + n + 1);

    solve_extrafast();

    return 0;
}
