#include <algorithm>
#include <iostream>
#include <cassert>

typedef long long llong;
const int MAXN = 1000000 + 10;
const int MAXLOG = 20;
const llong INF = 1e18;

llong a[MAXN], n, k;
llong dp[2][MAXN];

void calc(int l, int r, int optL, int optR, int currK)
{
    int mid = (l + r) / 2, opt = -1;
    dp[currK][mid] = INF;

    for (int i = std::max(mid+1, optL) ; i <= std::max(mid+1, optR) ; ++i)
    {
        if (dp[currK][mid] > dp[currK^1][i] + a[i-1] * (i - mid))
        {
            dp[currK][mid] = dp[currK^1][i] + a[i-1] * (i - mid);
            opt = i;
        }
    }
    
    if (l != r)
    {
        if (l <= mid-1) calc(l, mid-1, optL, (opt == -1 ? optR : opt), currK);
        if (mid+1 <= r) calc(mid+1, r, (opt == -1 ? optL : opt), optR, currK);
    }
}

void solve()
{
    std::sort(a+1, a+1+n);
    std::fill(dp[0]+1, dp[0]+n+1, INF);
    for (int currK = 1 ; currK <= k ; ++currK)
    {
        calc(1, n, 1, n+1, currK&1);
    }

    std::cout << dp[k&1][1] << '\n';
}

void read()
{
    std::cin >> n >> k;
    for (int i = 1 ; i <= n ; ++i)
    {
        std::cin >> a[i];
    }
}

void fastIO()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
}

int main()
{
    fastIO();
    read();
    solve();

    return 0;
}