#include <algorithm>
#include <iostream>
#include <cassert>
#include <vector>

typedef long long llong;
const int MAXN = 80000 + 10;

llong c[MAXN], n, q;
std::vector < int > v[MAXN];
std::vector < int > byColor[MAXN];
int vis[MAXN], timer;

int dfs(int node, int x, int y)
{
    int res = (c[node] == x);
    vis[node] = timer;
    for (int i : v[node])
    {
        if (vis[i] == timer || c[i] == y) continue;
        res += dfs(i, x, y);
    }

    return res;
}

void solve()
{
    for (int i = 1 ; i <= n ; ++i)
    {
        byColor[c[i]].push_back(i);
    }

    int x, y;
    llong ans;
    for (int i = 1 ; i <= q ; ++i)
    {
        ans = 0;
        ++timer;
        std::cin >> x >> y;
        if (byColor[x].size() <= 1)
        {
            std::cout << 0 << '\n';
            continue;
        }

        for (int j : byColor[x])
        {
            if (vis[j] == timer) continue;
            int res = dfs(j, x, y);
            ans += res * (res - 1) / 2;
        }

        std::cout << 1LL * byColor[x].size() * (byColor[x].size()-1) / 2 - ans << '\n';
    }
}

void read()
{
    std::cin >> n;
    for (int i = 1 ; i <= n ; ++i)
    {
        std::cin >> c[i];
    }

    int x, y;
    for (int i = 1 ; i <= n-1 ; ++i)
    {
        std::cin >> x >> y;
        v[x].push_back(y);
        v[y].push_back(x);
    }

    std::cin >> q;
}

void fastIO()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIO();
    read();
    solve();

    return 0;
}