#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

const ll maxn = 1e4 + 10;
const ll inf = 1e18;

ll n, k;
ll dp[maxn][maxn], r[maxn];

struct line
{
    ll k, m;

    line(ll _k, ll _m)
    {
        k = _k;
        m = _m;
    }

    double intersect(line &l)
    {
        return (double)(l.m - m) / (double)(k - l.k);
    }
};

struct convex_hull_trick
{
    vector < line > v;
    /// from large x to small x
    void add_line(ll k, ll m)
    {
        line l(k, m);
        while(v.size() > 2 && v[(ll)(v.size()) - 2].intersect(l) < v.back().intersect(v[(ll)(v.size()) - 2]))
            v.pop_back();
        v.push_back(l);
    }
    ll last_used = 0;
    ll query(ll x)
    {
        last_used = max((ll)(0), min(max((ll)(0), last_used - 5), (ll)(v.size()) - 2));
        while(last_used + 1 < v.size() && v[last_used + 1].k * x + v[last_used + 1].m <= v[last_used].k * x + v[last_used].m)
            last_used ++;


        ll sum = v[last_used].k * x + v[last_used].m;
        for (int i = max((ll)(0), last_used - 10); i < min((ll)v.size(), last_used + 11); i ++)
            if (v[i].k * x + v[i].m < sum)
            sum = v[i].k * x + v[i].m;
        ///return sum;

        ll lf = max((ll)0, last_used - 20), rf = min((ll)last_used + 20, (ll)(v.size()) - 2);
        while(lf <= rf)
        {
            ll mf = (lf + rf) / 2;
            if (v[mf].intersect(v[mf + 1]) > (double)(x))
                rf = rf - 1;
            else
                lf = lf + 1;
        }

        ///cout << lf << " " << last_used << endl;
    /**ll sp = min(p1, p2);*/
    for (int i = lf; i >= last_used; i --)
                    if (v[i].k * x + v[i].m < sum)
            sum = v[i].k * x + v[i].m;

        if (sum < 0)
        {
            cout << 1 / 0 << endl;
            exit(0);
        }

        last_used = lf;
        return v[lf].k * x + v[lf].m;
    }
};


convex_hull_trick cht[maxn];

void solve()
{
    cin >> n >> k;
    for (ll i = 1; i <= n; i ++)
        cin >> r[i];

        sort(r + 1, r + n + 1);
        reverse(r + 1, r + n + 1);
    for (ll i = 0; i <= n; i ++)
        for (ll j = 0; j <= k; j ++)
        dp[i][j] = inf;

    /**for (ll i = 1; i <= n; i ++)
        cout << r[i] << " ";
    cout << endl;*/
    dp[0][0] = 0;
    ll sum = 0;
    for (ll i = 1; i <= n; i ++)
    {


        for (ll j = k; j > 1; j --)
    {
        if (cht[j - 1].v.size() == 0)
            continue;

        dp[i][j] = cht[j - 1].query(i);

        cht[j].add_line(r[i + 1], (- i) * r[i + 1] + dp[i][j]);


        /**ll mx = r[i];
        for (ll i1 = i; i1 > 0; i1 --)
        {
            mx = max(mx, r[i1]);
            sum = dp[i1 - 1][j - 1] + mx * (ll)(i - i1 + 1);
            if (sum < dp[i][j])
                dp[i][j] = sum;
        }*/
    }
      dp[i][1] = r[1] * i;
         cht[1].add_line(r[i + 1], (- i) * r[i + 1] + dp[i][1]);
         ///cout << r[i + 1] << " -------- " << (- i) * r[i + 1] + dp[i][1] << endl;
    }


    /**for (ll i = 1; i <= n; i ++, cout << endl)
        for (ll j = 1; j <= k; j ++)
        cout << dp[i][j] << " ";
    cout << endl;*/
    cout << dp[n][k] << endl;

}

int main()
{
    solve();
    return 0;
}
